]> git.ipfire.org Git - thirdparty/dracut.git/blobdiff - 51-dracut-rescue.install
network-manager: don't run NetworkManager when there are no connections
[thirdparty/dracut.git] / 51-dracut-rescue.install
index 0a5f14be4e96a2cb7e7fa494eeea28728752fb7f..b4ed1783bdba8cbd09cac3750de71b9ec8b762df 100755 (executable)
@@ -33,19 +33,23 @@ dropindirs_sort()
 
 [[ -f /etc/os-release ]] && . /etc/os-release
 
-if [[ ! -f /etc/machine-id ]] || [[ ! -s /etc/machine-id ]]; then
-    systemd-machine-id-setup
+if [[ ${KERNEL_INSTALL_MACHINE_ID+x} ]]; then
+    MACHINE_ID=$KERNEL_INSTALL_MACHINE_ID
+elif [[ -f /etc/machine-id ]] ; then
+    read MACHINE_ID < /etc/machine-id
 fi
 
-[[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
+if ! [[ $MACHINE_ID ]]; then
+    exit 0
+fi
 
 if [[ -f /etc/kernel/cmdline ]]; then
     read -r -d '' -a BOOT_OPTIONS < /etc/kernel/cmdline
 elif [[ -f /usr/lib/kernel/cmdline ]]; then
     read -r -d '' -a BOOT_OPTIONS < /usr/lib/kernel/cmdline
-fi
+else
+    declare -a BOOT_OPTIONS
 
-if ! [[ "${BOOT_OPTIONS[@]}" ]]; then
     read -r -d '' -a line < /proc/cmdline
     for i in "${line[@]}"; do
         [[ "${i#initrd=*}" != "$i" ]] && continue
@@ -53,21 +57,26 @@ if ! [[ "${BOOT_OPTIONS[@]}" ]]; then
     done
 fi
 
-if ! [[ ${BOOT_OPTIONS[*]} ]]; then
-    echo "Could not determine the kernel command line parameters." >&2
-    echo "Please specify the kernel command line in /etc/kernel/cmdline!" >&2
-    exit 1
+if [[ -d "${BOOT_DIR_ABS%/*}" ]]; then
+    BOOT_DIR="/${MACHINE_ID}/0-rescue"
+    BOOT_ROOT=${BOOT_DIR_ABS%$BOOT_DIR}
+    LOADER_ENTRY="$BOOT_ROOT/loader/entries/${MACHINE_ID}-0-rescue.conf"
+    KERNEL="linux"
+    INITRD="initrd"
+else
+    BLS_DIR="/boot/loader/entries"
+    BOOT_DIR_ABS="/boot"
+    LOADER_ENTRY="$BLS_DIR/${MACHINE_ID}-0-rescue.conf"
+    KERNEL="vmlinuz-0-rescue-${MACHINE_ID}"
+    INITRD="initramfs-0-rescue-${MACHINE_ID}.img"
 fi
 
-BOOT_DIR="/${MACHINE_ID}/0-rescue"
-BOOT_ROOT=${BOOT_DIR_ABS%$BOOT_DIR}
-LOADER_ENTRY="$BOOT_ROOT/loader/entries/${MACHINE_ID}-0-rescue.conf"
-
 ret=0
 
 case "$COMMAND" in
     add)
-        [[ -f "$LOADER_ENTRY" ]] && exit 0
+        [[ -f "$LOADER_ENTRY" ]] && [[ -f "$BOOT_DIR_ABS/$KERNEL" ]] \
+            && [[ -f "$BOOT_DIR_ABS/$INITRD" ]] && exit 0
 
         # source our config dir
         for f in $(dropindirs_sort ".conf" "/etc/dracut.conf.d" "/usr/lib/dracut/dracut.conf.d"); do
@@ -78,21 +87,29 @@ case "$COMMAND" in
 
         [[ -d "$BOOT_DIR_ABS" ]] || mkdir -p "$BOOT_DIR_ABS"
 
-        if ! cp --reflink=auto "$KERNEL_IMAGE" "$BOOT_DIR_ABS"/linux; then
-            echo "Can't copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/linux'!" >&2
+        if ! cp --reflink=auto "$KERNEL_IMAGE" "$BOOT_DIR_ABS/$KERNEL"; then
+            echo "Can't copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/$KERNEL'!" >&2
         fi
 
-        dracut --no-hostonly -a "rescue" "$BOOT_DIR_ABS"/initrd "$KERNEL_VERSION"
-        ((ret+=$?))
+        if [[ ! -f "$BOOT_DIR_ABS/$INITRD" ]]; then
+            dracut -f --no-hostonly -a "rescue" "$BOOT_DIR_ABS/$INITRD" "$KERNEL_VERSION"
+            ((ret+=$?))
+        fi
+
+        if [[ "${BOOT_DIR_ABS}" != "/boot" ]]; then
+            {
+                echo "title      $PRETTY_NAME - Rescue Image"
+                echo "version    $KERNEL_VERSION"
+                echo "machine-id $MACHINE_ID"
+                echo "options    ${BOOT_OPTIONS[@]} rd.auto=1"
+                echo "linux      $BOOT_DIR/linux"
+                echo "initrd     $BOOT_DIR/initrd"
+            } > $LOADER_ENTRY
+        else
+            cp -aT "${KERNEL_IMAGE%/*}/bls.conf" $LOADER_ENTRY
+            sed -i 's/'$KERNEL_VERSION'/0-rescue-'${MACHINE_ID}'/' $LOADER_ENTRY
+        fi
 
-        {
-            echo "title      $PRETTY_NAME - Rescue Image"
-            echo "version    $KERNEL_VERSION"
-            echo "machine-id $MACHINE_ID"
-            echo "options    ${BOOT_OPTIONS[@]} rd.auto=1"
-            echo "linux      $BOOT_DIR/linux"
-            echo "initrd     $BOOT_DIR/initrd"
-        } > $LOADER_ENTRY
         ((ret+=$?))
         ;;
 
@@ -105,6 +122,4 @@ case "$COMMAND" in
         ret=1;;
 esac
 
-((ret+=$?))
-
 exit $ret